libdap::Array Class Reference

A multidimensional array of identical data types. More...

`#include <Array.h>`

Inheritance diagram for libdap::Array:

## Classes

struct | dimension
struct | var_chunk_info_t
struct | var_storage_info

## Public Types

typedef stack< BaseType * > | btp_stack
typedef std::vector< dimension >::const_iterator | Dim_citer
typedef std::vector< dimension >::iterator | Dim_iter

## Public Member Functions

virtual void | add_constraint (Dim_iter i, D4Dimension *dim)
virtual void | add_constraint (Dim_iter i, int start, int stride, int stop)
| Adds a constraint to an Array dimension.
virtual void | add_constraint_ll (Dim_iter i, int64_t start, int64_t stride, int64_t stop)
void | add_var (BaseType *v, Part p=nil) override
| Add the BaseType pointer to this constructor type instance.
void | add_var_nocopy (BaseType *v, Part p=nil) override
void | append_dim (D4Dimension *dim)
void | append_dim (int size, const string &name="")
| Add a dimension of a given size.
void | append_dim_ll (int64_t size, const string &name="")
| Array (const Array &rhs)
| The Array copy constructor.
| Array (const string &n, BaseType *v, bool is_dap4=false)
| Array constructor.
| Array (const string &n, const string &d, BaseType *v, bool is_dap4=false)
| Array constructor.
unsigned int | buf2val (void **val) override
| Copies data from the Vector buffer.
int64_t | buf2val_ll (void **val)
bool | check_semantics (string &msg, bool all=false) override
| Check semantic features of the Array.
void | clear_all_dims ()
virtual void | clear_constraint ()
| Clears the projection; add each projected dimension explicitly using `add_constraint`.
void | clear_local_data () override
void | compute_checksum (Crc32 &checksum) override
| include the data for this variable in the checksum DAP4 includes a checksum with every data response. This method adds the variable's data to that checksum.
virtual bool | d4_ops (BaseType *b, int op)
| Evaluator a relop for DAP4.
virtual string | dataset () const
| Returns the name of the dataset used to create this instance.
void | deserialize (D4StreamUnMarshaller &um, DMR &dmr) override
bool | deserialize (UnMarshaller &um, DDS *dds, bool reuse=false) override
| Receive data from the net.
Dim_iter | dim_begin ()
Dim_iter | dim_end ()
virtual D4Dimension * | dimension_D4dim (Dim_iter i)
virtual string | dimension_name (Dim_iter i)
| Returns the name of the specified dimension.
virtual int | dimension_size (Dim_iter i, bool constrained=false)
| Returns the size of the dimension.
virtual int64_t | dimension_size_ll (Dim_iter i, bool constrained=false)
virtual int | dimension_start (Dim_iter i, bool constrained=false)
| Return the start index of a dimension.
virtual int64_t | dimension_start_ll (Dim_iter i, bool constrained=false)
virtual int | dimension_stop (Dim_iter i, bool constrained=false)
| Return the stop index of the constraint.
virtual int64_t | dimension_stop_ll (Dim_iter i, bool constrained=false)
virtual int | dimension_stride (Dim_iter i, bool constrained=false)
| Returns the stride value of the constraint.
virtual int64_t | dimension_stride_ll (Dim_iter i, bool constrained=false)
virtual unsigned int | dimensions (bool constrained=false)
| Return the total number of dimensions in the array.
void | dump (ostream &strm) const override
| dumps information about this object
int | element_count (bool leaves) override
| Count the members of constructor types.
virtual std::string | FQN () const
virtual BaseType * | get_ancestor ()
virtual AttrTable & | get_attr_table ()
char * | get_buf ()
vector< BaseType * > & | get_compound_buf ()
bool | get_dio_flag () const
virtual BaseType * | get_parent () const
vector< string > & | get_str ()
virtual unsigned int | get_value_capacity () const
virtual uint64_t | get_value_capacity_ll () const
var_storage_info & | get_var_storage_info ()
void | intern_data () override
| Read data into this variable.
void | intern_data (ConstraintEvaluator &eval, DDS &dds) override
| read data into a variable for later use
virtual bool | is_constructor_type () const
| Returns true if the instance is a constructor (i.e., Structure, Sequence or Grid) type variable.
bool | is_dap2_grid ()
virtual bool | is_dap4 () const
bool | is_dap4_projected (std::vector< std::string > &projected_dap4_inventory) override
virtual bool | is_in_selection ()
| Is this variable part of the current selection?
virtual bool | is_simple_type () const
| Returns true if the instance is a numeric, string or URL type variable.
virtual bool | is_vector_type () const
| Returns true if the instance is a vector (i.e., array) type variable.
int | length () const override
| Returns the number of elements in the vector. Note that some child classes of Vector use the length of -1 as a flag value.
int64_t | length_ll () const override
| Get the number of elements in this Vector/Array This version of the function deprecates length() which is limited to 32-bit sizes. The field uses -1 as a sentinel value indicating that the Vector/Array holds no values yet (as opposed to zero values).
virtual D4Maps * | maps ()
virtual string | name () const
| Returns the name of the class instance.
Array & | operator= (const Array &rhs)
virtual bool | ops (BaseType *b, int op)
| Evaluate relational operators.
void | prepend_dim (D4Dimension *dim)
void | prepend_dim (int size, const string &name="")
virtual void | print_as_map_xml (FILE *out, string space=" ", bool constrained=false)
virtual void | print_as_map_xml (ostream &out, string space=" ", bool constrained=false)
virtual void | print_as_map_xml_writer (XMLWriter &xml, bool constrained)
void | print_dap4 (XMLWriter &xml, bool constrained=false) override
| Print the DAP4 representation of an array.
void | print_decl (FILE *out, string space=" ", bool print_semi=true, bool constraint_info=false, bool constrained=false) override
| Prints a DDS entry for the Array.
void | print_decl (ostream &out, string space=" ", bool print_semi=true, bool constraint_info=false, bool constrained=false) override
| Prints a DDS entry for the Array.
void | print_val (FILE *out, string space="", bool print_decl_p=true) override
| Prints the value of the variable.
void | print_val (ostream &out, string space="", bool print_decl_p=true) override
| Prints the value of the variable.
void | print_xml (FILE *out, string space=" ", bool constrained=false) override
void | print_xml (ostream &out, string space=" ", bool constrained=false) override
virtual void | print_xml_core (FILE *out, string space, bool constrained, string tag)
virtual void | print_xml_core (ostream &out, string space, bool constrained, string tag)
void | print_xml_writer (XMLWriter &xml, bool constrained=false) override
virtual void | print_xml_writer_core (XMLWriter &out, bool constrained, string tag)
virtual BaseType * | prototype () const
BaseType * | ptr_duplicate () override
virtual bool | read ()
| Read data into a local buffer.
virtual bool | read_p ()
| Has this variable been read?
void | rename_dim (const string &oldName="", const string &newName="")
| Renames dimension.
virtual void | reserve_value_capacity ()
virtual void | reserve_value_capacity (unsigned int numElements)
virtual void | reserve_value_capacity_ll ()
virtual void | reserve_value_capacity_ll (uint64_t numElements)
virtual void | reserve_value_capacity_ll_byte (uint64_t numBytes)
virtual void | reset_constraint ()
| Reset constraint to select entire array.
virtual bool | send_p ()
| Should this variable be sent?
bool | serialize (ConstraintEvaluator &eval, DDS &dds, Marshaller &m, bool ce_eval=true) override
| Serialize a Vector.
void | serialize (D4StreamMarshaller &m, DMR &dmr, bool filter=false) override
| The DAP4 serialization method. Serialize a variable's values for DAP4. This does not write the DMR persistent representation but does write that part of the binary data blob that holds a variable's data. Once a variable's data are serialized, that memory is reclaimed (by calling BaseType::clear_local_data())
virtual void | set_attr_table (const AttrTable &at)
void | set_dio_flag (bool dio_flag_value=true)
virtual void | set_in_selection (bool state)
virtual void | set_is_dap4 (const bool v)
void | set_length (int64_t l) override
| Sets the length of the vector. This function does not allocate any new space.
void | set_length_ll (int64_t l) override
| Set the number of elements in this Vector/Array This version of the function deprecates set_length() which is limited to 32-bit sizes. The field uses -1 as a sentinel value indicating that the Vector/Array holds no values.
void | set_name (const std::string &name) override
| Sets the name of the class instance.
virtual void | set_parent (BaseType *parent)
virtual BaseType * | set_prototype (BaseType *btp)
| Change the Vector/Array element type.
void | set_read_p (bool state) override
| Indicates that the data is ready to send.
void | set_send_p (bool state) override
| Indicates that the data is ready to send.
virtual void | set_synthesized_p (bool state)
virtual void | set_type (const Type &t)
| Sets the type of the class instance.
virtual bool | set_value (dods_byte *val, int sz)
virtual bool | set_value (dods_float32 *val, int sz)
virtual bool | set_value (dods_float64 *val, int sz)
virtual bool | set_value (dods_int16 *val, int sz)
virtual bool | set_value (dods_int32 *val, int sz)
virtual bool | set_value (dods_int64 *val, int sz)
virtual bool | set_value (dods_int8 *val, int sz)
virtual bool | set_value (dods_uint16 *val, int sz)
virtual bool | set_value (dods_uint32 *val, int sz)
virtual bool | set_value (dods_uint64 *val, int sz)
virtual bool | set_value (string *val, int sz)
| set the value of a string or url array
virtual bool | set_value (vector< dods_byte > &val, int sz)
virtual bool | set_value (vector< dods_float32 > &val, int sz)
virtual bool | set_value (vector< dods_float64 > &val, int sz)
virtual bool | set_value (vector< dods_int16 > &val, int sz)
virtual bool | set_value (vector< dods_int32 > &val, int sz)
virtual bool | set_value (vector< dods_int64 > &val, int sz)
virtual bool | set_value (vector< dods_int8 > &val, int sz)
virtual bool | set_value (vector< dods_uint16 > &val, int sz)
virtual bool | set_value (vector< dods_uint32 > &val, int sz)
virtual bool | set_value (vector< dods_uint64 > &val, int sz)
virtual bool | set_value (vector< string > &val, int sz)
| set the value of a string or url array
void | set_value_capacity (uint64_t l)
virtual bool | set_value_ll (dods_byte *val, int64_t sz)
virtual bool | set_value_ll (dods_float32 *val, int64_t sz)
virtual bool | set_value_ll (dods_float64 *val, int64_t sz)
virtual bool | set_value_ll (dods_int16 *val, int64_t sz)
virtual bool | set_value_ll (dods_int32 *val, int64_t sz)
virtual bool | set_value_ll (dods_int64 *val, int64_t sz)
virtual bool | set_value_ll (dods_int8 *val, int64_t sz)
virtual bool | set_value_ll (dods_uint16 *val, int64_t sz)
virtual bool | set_value_ll (dods_uint32 *val, int64_t sz)
virtual bool | set_value_ll (dods_uint64 *val, int64_t sz)
virtual bool | set_value_ll (string *val, int64_t sz)
virtual bool | set_value_ll (vector< dods_byte > &val, int64_t sz)
virtual bool | set_value_ll (vector< dods_float32 > &val, int64_t sz)
virtual bool | set_value_ll (vector< dods_float64 > &val, int64_t sz)
virtual bool | set_value_ll (vector< dods_int16 > &val, int64_t sz)
virtual bool | set_value_ll (vector< dods_int32 > &val, int64_t sz)
virtual bool | set_value_ll (vector< dods_int64 > &val, int64_t sz)
virtual bool | set_value_ll (vector< dods_int8 > &val, int64_t sz)
virtual bool | set_value_ll (vector< dods_uint16 > &val, int64_t sz)
virtual bool | set_value_ll (vector< dods_uint32 > &val, int64_t sz)
virtual bool | set_value_ll (vector< dods_uint64 > &val, int64_t sz)
virtual bool | set_value_ll (vector< string > &val, int64_t sz)
virtual uint64_t | set_value_slice_from_row_major_vector (const Vector &rowMajorData, uint64_t startElement)
void | set_var_storage_info (const var_storage_info &my_vs_info)
| Set the variable storage information for direct IO optimization.
void | set_vec (unsigned int i, BaseType *val)
| Sets element i to value val.
void | set_vec_ll (uint64_t i, BaseType *val)
void | set_vec_nocopy (unsigned int i, BaseType *val)
| Sets element i to value val. Set the ith element to val. Extend the vector if needed.
void | set_vec_nocopy_ll (uint64_t i, BaseType *val)
virtual bool | synthesized_p ()
virtual string | toString ()
virtual void | transfer_attributes (AttrTable *at)
std::vector< BaseType * > * | transform_to_dap2 (AttrTable *parent_attr_table) override
| Transforms this instance of a D4Array into the corresponding DAP2 object.
void | transform_to_dap4 (D4Group *root, Constructor *container) override
| DAP2 to DAP4 transform.
virtual Type | type () const
| Returns the type of the class instance.
virtual string | type_name () const
| Returns the type of the class instance as a string.
virtual void | update_length (int size=0)
virtual void | update_length_ll (unsigned long long size=0)
unsigned int | val2buf (void *val, bool reuse=false) override
| Reads data into the Vector buffer.
int64_t | val2buf_ll (void *val, bool reuse=false)
virtual void * | value ()
virtual void | value (dods_byte *b) const
virtual void | value (dods_float32 *b) const
virtual void | value (dods_float64 *b) const
virtual void | value (dods_int16 *b) const
virtual void | value (dods_int32 *b) const
virtual void | value (dods_int64 *b) const
virtual void | value (dods_int8 *b) const
virtual void | value (dods_uint16 *b) const
virtual void | value (dods_uint32 *b) const
virtual void | value (dods_uint64 *b) const
virtual void | value (vector< string > &b) const
| Get a copy of the data held by this variable.
virtual void | value (vector< unsigned int > *index, vector< string > &b) const
| Get a copy of the data held by this variable using the passed subsetIndex vector to identify which values to return.
virtual void | value (vector< unsigned int > *indices, dods_byte *b) const
virtual void | value (vector< unsigned int > *indices, dods_float32 *b) const
virtual void | value (vector< unsigned int > *indices, dods_float64 *b) const
virtual void | value (vector< unsigned int > *indices, dods_int16 *b) const
virtual void | value (vector< unsigned int > *indices, dods_int32 *b) const
virtual void | value (vector< unsigned int > *indices, dods_int64 *b) const
virtual void | value (vector< unsigned int > *indices, dods_int8 *b) const
virtual void | value (vector< unsigned int > *indices, dods_uint16 *b) const
virtual void | value (vector< unsigned int > *indices, dods_uint32 *b) const
virtual void | value (vector< unsigned int > *indices, dods_uint64 *b) const
virtual void | value_ll (vector< uint64_t > *index, vector< string > &b) const
virtual void | value_ll (vector< uint64_t > *indices, dods_byte *b) const
virtual void | value_ll (vector< uint64_t > *indices, dods_float32 *b) const
virtual void | value_ll (vector< uint64_t > *indices, dods_float64 *b) const
virtual void | value_ll (vector< uint64_t > *indices, dods_int16 *b) const
virtual void | value_ll (vector< uint64_t > *indices, dods_int32 *b) const
virtual void | value_ll (vector< uint64_t > *indices, dods_int64 *b) const
virtual void | value_ll (vector< uint64_t > *indices, dods_int8 *b) const
virtual void | value_ll (vector< uint64_t > *indices, dods_uint16 *b) const
virtual void | value_ll (vector< uint64_t > *indices, dods_uint32 *b) const
virtual void | value_ll (vector< uint64_t > *indices, dods_uint64 *b) const
BaseType * | var (const string &name, btp_stack &s) override
BaseType * | var (const string &name="", bool exact_match=true, btp_stack *s=nullptr) override
virtual BaseType * | var (unsigned int i)
virtual BaseType * | var_ll (uint64_t i)
void | vec_resize (int l)
void | vec_resize_ll (int64_t l)
unsigned int | width (bool constrained=false) const override
| Returns the width of the data, in bytes.
int64_t | width_ll (bool constrained=false) const override
| Return the number of bytes needed to hold the array data.
virtual | ~Array ()
| The Array destructor.
virtual D4Attributes * | attributes ()
virtual void | set_attributes (D4Attributes *)
virtual void | set_attributes_nocopy (D4Attributes *)

## Protected Member Functions

void | _duplicate (const Array &a)
void | m_duplicate (const BaseType &bt)
| Perform a deep copy.
uint64_t | print_array (FILE *out, uint64_t index, unsigned int dims, uint64_t shape[])
| Print the value given the current constraint.
uint64_t | print_array (ostream &out, uint64_t index, unsigned int dims, uint64_t shape[])
| Print the value given the current constraint.
std::vector< dimension > & | shape ()

## Friends

class | ArrayTest
class | D4Group

## Detailed Description

A multidimensional array of identical data types.

This class is used to hold arrays of data. The elements of the array can be simple or compound data types. There is no limit on the number of dimensions an array can have, or on the size of each dimension.

If desired, the user can give each dimension of an array a name. You can, for example, have a 360x180 array of temperatures, covering the whole globe with one-degree squares. In this case, you could name the first dimension Longitude and the second dimension Latitude. This can help prevent a great deal of confusion.

The Array is used as part of the Grid class, where the dimension names are crucial to its structure. The dimension names correspond to Map vectors, holding the actual values for that column of the array.

In DAP4, the Array may be a Coverage or a simple Array. In the former case the Array will have both named dimensions and maps, where the maps (instances of D4Map) are what make the Array a Coverage. Coverages are a generalization of DAP2 Grids.

Each array dimension carries with it its own projection information. The projection information takes the form of three integers: the start, stop, and stride values. This is clearest with an example. Consider a one-dimensional array 10 elements long. If the start value of the dimension constraint is 3, then the constrained array appears to be seven elements long. If the stop value is changed to 7, then the array appears to be five elements long. If the stride is changed to two, the array will appear to be 3 elements long. Array constraints are written as: [start:stride:stop].

    A = [1 2 3 4 5 6 7 8 9 10]

    A[3::] = [4 5 6 7 8 9 10]

    A[3::7] = [4 5 6 7 8]

    A[3:2:7] = [4 6 8]

    A[0:3:9] = [1 4 7 10]

Note
  Arrays use zero-based indexing.
  This class is used for both DAP2 and DAP4.
  An interesting 'feature' of the DAP4 Array is that its Maps are added after construction. None of the Array constructors build the Maps, but the copy ctor is supposed to copy it correctly. The original design has pointers for the parent and the source of the Map's value, but the actual 'parent' array is the object being constructed, so it does not exist! I have thus replaced the pointers with paths. Use the dataset's root group find_var() method to get the objects. The root group can be found using the new BaseType::get_ancestor() method. jhrg 9/16/22

See also
  Grid
  Vector
  dimension

Definition at line 121 of file Array.h.

## Member Typedef Documentation

## btp_stack

typedef stack<BaseType *> libdap::BaseType::btp_stack

inherited

Definition at line 149 of file BaseType.h.

## Dim_citer

typedef std::vector<dimension>::const_iterator libdap::Array::Dim_citer

A constant iterator used to access the various dimensions of an Array.

See also
  dim_begin()
  dim_end()

Definition at line 227 of file Array.h.

## Dim_iter

typedef std::vector<dimension>::iterator libdap::Array::Dim_iter

An iterator used to access the various dimensions of an Array. Most of the methods that access various properties of a dimension use an instance of Dim_iter.

See also
  dim_begin()
  dim_end()

Definition at line 235 of file Array.h.

## Constructor & Destructor Documentation

## Array() [1/3]

libdap::Array::Array | ( | const string & | n,
|  | BaseType * | v,
|  | bool | is_dap4 = `false`
| ) |  |

Array constructor.

Build an array with a name and an element type. The name may be omitted, which will create a nameless variable. The template (element type) pointer may also be omitted, but if it is omitted when the Array is created, it must be added (with `add_var()` od add_var_nocopy()) before `read()` or `deserialize()` is called.

This version of add_var() calls Array::add_var().

Parameters

  n | A string containing the name of the variable to be created.
  v | A pointer to a variable of the type to be included in the Array. May be null and set later using add_var() or add_var_nocopy()

Definition at line 133 of file Array.cc.

## Array() [2/3]

libdap::Array::Array | ( | const string & | n,
|  | const string & | d,
|  | BaseType * | v,
|  | bool | is_dap4 = `false`
| ) |  |

Array constructor.

Build an array on the server-side with a name, a dataset name from which this Array is being created, and an element type.

This version of add_var() calls Array::add_var().

Parameters

  n | A string containing the name of the variable to be created.
  d | A string containing the name of the dataset from which this variable is being created.
  v | A pointer to a variable of the type to be included in the Array.

Definition at line 152 of file Array.cc.

## Array() [3/3]

libdap::Array::Array | ( | const Array & | rhs | ) |

The Array copy constructor.

Definition at line 160 of file Array.cc.

## ~Array()

libdap::Array::~Array | ( |  | ) |

virtual

The Array destructor.

Definition at line 163 of file Array.cc.

## Member Function Documentation

## _duplicate()

void libdap::Array::_duplicate | ( | const Array & | a | ) |

protected

Definition at line 75 of file Array.cc.

## add_constraint() [1/2]

void libdap::Array::add_constraint | ( | Dim_iter | i,
|  | D4Dimension * | dim
| ) |  |

virtual

Definition at line 703 of file Array.cc.

## add_constraint() [2/2]

void libdap::Array::add_constraint | ( | Dim_iter | i,
|  | int | start,
|  | int | stride,
|  | int | stop
| ) |  |

virtual

Adds a constraint to an Array dimension.

Once a dimension has been created (see append_dim()), it can be constrained. This will make the array appear to the rest of the world to be smaller than it is. This functions sets the projection for a dimension, and marks that dimension as part of the current projection.

Note
  A stride value <= 0 or > the array size is an error and causes add_constraint to throw an Error. Similarly, start or stop values > size also cause an Error exception to be thrown.

Parameters

  i | An iterator pointing to the dimension in the list of dimensions.
  start | The start index of the constraint.
  stride | The stride value of the constraint.
  stop | The stop index of the constraint. A value of -1 indicates 'to the end' of the array.

Exceptions

  Error | Thrown if the any of values of start, stop or stride cannot be applied to this array.

Definition at line 627 of file Array.cc.

## add_constraint_ll()

void libdap::Array::add_constraint_ll | ( | Dim_iter | i,
|  | int64_t | start,
|  | int64_t | stride,
|  | int64_t | stop
| ) |  |

virtual

Definition at line 669 of file Array.cc.

## add_var()

void libdap::Array::add_var | ( | BaseType * | v,
|  | Part | p = `nil`
| ) |  |

override virtual

Add the BaseType pointer to this constructor type instance.

Propagate the name of the BaseType instance to this instance. This ensures that variables at any given level of the DDS table have unique names (i.e., that Arrays do not have their default name ""). If `v`'s name is null, then assume that the array is named and don't overwrite it with `v`'s null name.

Note
  It is possible for the BaseType pointer to be null when this method is called, a behavior that differs considerably from that of the other 'add_var()' methods.
  This version checks to see if v is an array. If so, it calls Vector::add_var() using the template variable of v and then appends the dimensions of v to this array. This somewhat obscure behavior simplifies 'translating' Sequences to arrays when the actual variable being translated is not a regular Sequence but an array of Sequences. This is of very debatable usefulness, but it's here all the same.

Parameters

  v | The template variable for the array
  p | The Part parameter defaults to nil and is ignored by this method.

Reimplemented from libdap::BaseType.

Definition at line 456 of file Array.cc.

## add_var_nocopy()

void libdap::Array::add_var_nocopy | ( | BaseType * | v,
|  | Part | p = `nil`
| ) |  |

override virtual

Reimplemented from libdap::BaseType.

Definition at line 475 of file Array.cc.

## append_dim() [1/2]

void libdap::Array::append_dim | ( | D4Dimension * | dim | ) |

Definition at line 522 of file Array.cc.

## append_dim() [2/2]

void libdap::Array::append_dim | ( | int | size,
|  | const string & | name = `""`
| ) |  |

Add a dimension of a given size.

Given a size and a name, this function adds a dimension to the array. For example, if the Array is already 10 elements long, calling `append_dim` with a size of 5 will transform the array into a 10x5 matrix. Calling it again with a size of 2 will create a 10x5x2 array, and so on. This sets Vector's length member as a side effect.

Parameters

  size | The size of the desired new row.
  name | The name of the new dimension. This defaults to an empty string.

Definition at line 504 of file Array.cc.

## append_dim_ll()

void libdap::Array::append_dim_ll | ( | int64_t | size,
|  | const string & | name = `""`
| ) |  |

Definition at line 511 of file Array.cc.

## attributes()

D4Attributes * libdap::BaseType::attributes | ( |  | ) |

virtual inherited

DAP4 Attribute methods

Definition at line 507 of file BaseType.cc.

## buf2val()

unsigned int libdap::Vector::buf2val | ( | void ** | val | ) |

override virtual inherited

Copies data from the Vector buffer.

Copy data from a numeric or string arry to a buffer. This method will allocate memory if the handle `val` references NULL, otherwise it assumes the handle references enough storage for the data to be copied.

Never call this method for constructor types Structure, Sequence or Grid.

When reading data out of a variable that has been constrained, this method assumes the N values/bytes of constrained data start at the beginning of the object's internal buffer. For example, do not load an entire Vector's data using val2buf(), constrain and then use this method to get the data. Unless your constraint starts with the [0]th element, the result will not be the correct values.

In the case of a Vector of Str objects, this method will return a pointer to an array of C++ std::string objects.

Note
  It's best to define the pointer to reference the data as 'char *data' or some other non-void type and then call this method using '..->buf2val((void**)&data)'. You must free the storage once you're done using 'delete[] data'.
  It's also important to initialize the handle to NULL. That is your code should declare the handle like this: 'char *data = 0' if it expects buf2val() to allocate memory. With most compilers, the pointer may be null the first time the code is run, but often not on subsequent calls.

Returns
  The number of bytes used to store the array.

Parameters

  val | A pointer to a pointer to the memory into which the class data will be copied. If the value pointed to is NULL, memory will be allocated to hold the data, and the pointer value modified accordingly. The calling program is responsible for deallocating the memory indicated by this pointer.

Exceptions

  InternalErr | Thrown if val is null.

See also
  Vector::set_vec

Implements libdap::BaseType.

Definition at line 1422 of file Vector.cc.

## buf2val_ll()

int64_t libdap::Vector::buf2val_ll | ( | void ** | val | ) |

inherited

Definition at line 1479 of file Vector.cc.

## check_semantics()

bool libdap::Array::check_semantics | ( | string & | msg,
|  | bool | all = `false`
| ) |  |

override virtual

Check semantic features of the Array.

This function checks semantic features of the Array. Currently, the only check specific to the Array is that there must be dimensions. The rest is inherited from `BaseType::check_semantics()`.

Returns
  A boolean value. FALSE means there was a problem.

Reimplemented from libdap::BaseType.

Definition at line 1319 of file Array.cc.

## clear_all_dims()

void libdap::Array::clear_all_dims | ( |  | ) |

Remove all the dimensions currently set for the Array. This also removes all constraint information.

Definition at line 553 of file Array.cc.

## clear_constraint()

void libdap::Array::clear_constraint | ( |  | ) |

virtual

Clears the projection; add each projected dimension explicitly using `add_constraint`.

Tell the Array object to clear the constraint information about dimensions. Do this once before calling `add_constraint()` for each new constraint expression. Only the dimensions explicitly selected using `add_constraint()` will be sent.

Deprecated:
  This should never be used.

Definition at line 600 of file Array.cc.

## clear_local_data()

void libdap::Vector::clear_local_data | ( |  | ) |

override virtual inherited

Remove any read or set data in the private data of this Vector, setting read_p() to false. Essentially clears the _buf, d_str, and d_compound_buf of any data. Useful for tightening up memory when the data are no longer needed, but the object cannot yet be destroyed.

On exit: get_value_capacity() == 0 && !read_p()

Reimplemented from libdap::BaseType.

Definition at line 1636 of file Vector.cc.

## compute_checksum()

void libdap::Vector::compute_checksum | ( | Crc32 & | checksum | ) |

override virtual inherited

include the data for this variable in the checksum DAP4 includes a checksum with every data response. This method adds the variable's data to that checksum.

Parameters

  checksum | A Crc32 instance that holds the current checksum.

Implements libdap::BaseType.

Definition at line 939 of file Vector.cc.

## d4_ops()

bool libdap::BaseType::d4_ops | ( | BaseType * | b,
|  | int | op
| ) |  |

virtual inherited

Evaluator a relop for DAP4.

This method is used by the filter expression evaluation code in DAP4. Each of the 'data type' classes that support relops must overload this method. In an expression of the form arg1 op arg2, this object is arg1, the parameter 'b' is arg2 and op is the relational operator.

Note
  I used the same relop codes for DAP4 as in the DAP2 parser/scanner which makes for some coupling between them, but cuts way down on the duplication of the evaluator logic, which is somewhat involved.

Parameters

  b | The second argument in the relational expression
  op | The infix relational operator

Returns
  True if the expression is true, False otherwise.

Reimplemented in libdap::Byte, libdap::Float32, libdap::Float64, libdap::Int16, libdap::Int32, libdap::Int64, libdap::Int8, libdap::Str, and libdap::UInt64.

Definition at line 1125 of file BaseType.cc.

## dataset()

string libdap::BaseType::dataset | ( |  | ) | const

virtual inherited

Returns the name of the dataset used to create this instance.

A dataset from which the data is to be read. The meaning of this string will vary among different types of data sources. It may be the name of a data file or an identifier used to read data from a relational database.

Definition at line 326 of file BaseType.cc.

## deserialize() [1/2]

void libdap::Vector::deserialize | ( | D4StreamUnMarshaller & | um,
|  | DMR & | dmr
| ) |  |

override virtual inherited

The DAP4 deserialization method.

Parameters

  um |
  dmr |

Exceptions

  Error | or InternalErr

Reimplemented from libdap::BaseType.

Definition at line 1109 of file Vector.cc.

## deserialize() [2/2]

bool libdap::Vector::deserialize | ( | UnMarshaller & | um,
|  | DDS * | dds,
|  | bool | reuse = `false`
| ) |  |

override virtual inherited

Receive data from the net.

Receives data from the network connection identified by the `source` parameter. The data is put into the class data buffer according to the input `dds`.

This function is only used on the client side of the DODS client/server connection.

Parameters

  um | An UnMarshaller that knows how to deserialize data types
  dds | The Data Descriptor Structure object corresponding to this dataset. See The DODS User Manual for information about this structure. This would have been received from the server in an earlier transmission.
  reuse | A boolean value, indicating whether the class internal data storage can be reused or not. If this argument is TRUE, the class buffer is assumed to be large enough to hold the incoming data, and it is not reallocated. If FALSE, new storage is allocated. If the internal buffer has not been allocated at all, this argument has no effect.

Returns
  Always returns TRUE.

Exceptions

  Error | when a problem reading from the UnMarshaller is found.

See also
  DDS

Reimplemented from libdap::BaseType.

Definition at line 831 of file Vector.cc.

## dim_begin()

Array::Dim_iter libdap::Array::dim_begin | ( |  | ) |

Returns an iterator to the first dimension of the Array.

Definition at line 718 of file Array.cc.

## dim_end()

Array::Dim_iter libdap::Array::dim_end | ( |  | ) |

Returns an iterator past the last dimension of the Array.

Definition at line 721 of file Array.cc.

## dimension_D4dim()

D4Dimension * libdap::Array::dimension_D4dim | ( | Dim_iter | i | ) |

virtual

Definition at line 887 of file Array.cc.

## dimension_name()

string libdap::Array::dimension_name | ( | Dim_iter | i | ) |

virtual

Returns the name of the specified dimension.

This function returns the name of the dimension indicated with p. Since this method is public, it is possible to call it before the Array object has been properly initialized. This will cause an exception. So don't do that.

Parameters

  i | The dimension.

Returns
  A pointer to a string containing the dimension name.

Definition at line 876 of file Array.cc.

## dimension_size()

int libdap::Array::dimension_size | ( | Dim_iter | i,
|  | bool | constrained = `false`
| ) |  |

virtual

Returns the size of the dimension.

Return the size of the array dimension referred to by i. If the dimension is constrained the constrained size is returned if constrained is `true`.

Parameters

  i | The dimension.
  constrained | If this parameter is TRUE, the method returns the constrained size of the array so long as a constraint has been applied to this dimension. If TRUE and no constraint has been applied, this method returns zero. If it is FALSE, the method ignores any constraint that has been applied to this dimension and returns the full size of the dimension. The default value is FALSE.

Returns
  An integer containing the size of the specified dimension.

Definition at line 752 of file Array.cc.

## dimension_size_ll()

int64_t libdap::Array::dimension_size_ll | ( | Dim_iter | i,
|  | bool | constrained = `false`
| ) |  |

virtual

Definition at line 848 of file Array.cc.

## dimension_start()

int libdap::Array::dimension_start | ( | Dim_iter | i,
|  | bool | constrained = `false`
| ) |  |

virtual

Return the start index of a dimension.

Use this function to return the start index of an array dimension. If the array is constrained (indicated with the constrained argument), the start index of the constrained array is returned (or zero if the dimension in question is not selected at all). See also `dimension_stop()` and `dimension_stride()`.

Parameters

  i | The dimension.
  constrained | If this parameter is TRUE, the function returns the start index only if the dimension is constrained (subject to a start, stop, or stride constraint). If the dimension is not constrained, the function returns zero. If it is FALSE, the function returns the start index whether or not the dimension is constrained.

Returns
  The desired start index.

Definition at line 790 of file Array.cc.

## dimension_start_ll()

int64_t libdap::Array::dimension_start_ll | ( | Dim_iter | i,
|  | bool | constrained = `false`
| ) |  |

virtual

Definition at line 860 of file Array.cc.

## dimension_stop()

int libdap::Array::dimension_stop | ( | Dim_iter | i,
|  | bool | constrained = `false`
| ) |  |

virtual

Return the stop index of the constraint.

Use this function to return the stop index of an array dimension. If the array is constrained (indicated with the constrained argument), the stop index of the constrained array is returned (or zero if the dimension in question is not selected at all). See also `dimension_start()` and `dimension_stride()`.

Parameters

  i | The dimension.
  constrained | If this parameter is TRUE, the function returns the stop index only if the dimension is constrained (subject to a start, stop, or stride constraint). If the dimension is not constrained, the function returns zero. If it is FALSE, the function returns the stop index whether or not the dimension is constrained.

Returns
  The desired stop index.

Definition at line 815 of file Array.cc.

## dimension_stop_ll()

int64_t libdap::Array::dimension_stop_ll | ( | Dim_iter | i,
|  | bool | constrained = `false`
| ) |  |

virtual

Definition at line 862 of file Array.cc.

## dimension_stride()

int libdap::Array::dimension_stride | ( | Dim_iter | i,
|  | bool | constrained = `false`
| ) |  |

virtual

Returns the stride value of the constraint.

Use this function to return the stride value of an array dimension. If the array is constrained (indicated with the constrained argument), the stride value of the constrained array is returned (or zero if the dimension in question is not selected at all). See also `dimension_stop()` and `dimension_start()`.

Parameters

  i | The dimension.
  constrained | If this parameter is TRUE, the function returns the stride value only if the dimension is constrained (subject to a start, stop, or stride constraint). If the dimension is not constrained, the function returns zero. If it is FALSE, the function returns the stride value whether or not the dimension is constrained.

Returns
  The stride value requested, or zero, if constrained is TRUE and the dimension is not selected.

Definition at line 841 of file Array.cc.

## dimension_stride_ll()

int64_t libdap::Array::dimension_stride_ll | ( | Dim_iter | i,
|  | bool | constrained = `false`
| ) |  |

virtual

Definition at line 864 of file Array.cc.

## dimensions()

unsigned int libdap::Array::dimensions | ( | bool | constrained = `false` | ) |

virtual

Return the total number of dimensions in the array.

Return the total number of dimensions contained in the array. When constrained is TRUE, return the number of dimensions given the most recently evaluated constraint expression.

Parameters

  constrained | A boolean flag to indicate whether the array is constrained or not. Ignored.

Definition at line 733 of file Array.cc.

## dump()

void libdap::Array::dump | ( | ostream & | strm | ) | const

override virtual

dumps information about this object

Displays the pointer value of this instance and information about this instance.

Parameters

  strm | C++ i/o stream to dump the information to

Returns
  void

Implements libdap::DapObj.

Definition at line 1379 of file Array.cc.

## element_count()

int libdap::Vector::element_count | ( | bool | leaves | ) |

override virtual inherited

Count the members of constructor types.

Return a count of the total number of variables in this variable. This is used to count the number of variables held by a constructor variable - for simple type and vector variables it always returns 1.

For compound data types, there are two ways to count members. You can count the members, or you can count the simple members and add that to the count of the compound members. For example, if a Structure contains an Int32 and another Structure that itself contains two Int32 members, the element count of the top-level structure could be two (one Int32 and one Structure) or three (one Int32 by itself and two Int32's in the subsidiary Structure). Use the leaves parameter to control which kind of counting you desire.

Returns
  Returns 1 for simple types. For compound members, the count depends on the leaves argument.

Parameters

  leaves | This parameter is only relevant if the object contains other compound data types. If FALSE, the function counts only the data variables mentioned in the object's declaration. If TRUE, it counts the simple members, and adds that to the sum of the counts for the compound members. This parameter has no effect for simple type variables.

Reimplemented from libdap::BaseType.

Definition at line 332 of file Vector.cc.

## FQN()

string libdap::BaseType::FQN | ( |  | ) | const

virtual inherited

Return the FQN for this variable. This will include the D4 Group component of the name.

Returns
  The FQN in a string

Reimplemented in libdap::Constructor, and libdap::D4Group.

Definition at line 304 of file BaseType.cc.

## get_ancestor()

BaseType * libdap::BaseType::get_ancestor | ( |  | ) |

virtual inherited

Definition at line 638 of file BaseType.cc.

## get_attr_table()

AttrTable & libdap::BaseType::get_attr_table | ( |  | ) |

virtual inherited

Get this variable's AttrTable. It's generally a bad idea to return a reference to a contained object, but in this case it seems that building an interface inside BaseType is overkill.

Use the AttrTable methods to manipulate the table.

Definition at line 498 of file BaseType.cc.

## get_buf()

char * libdap::Vector::get_buf | ( |  | ) |

inline inherited

Provide access to internal data. Callers cannot delete this but can pass them to other methods.

Note
  Added so that the NCML handler can code some optimizations in its specialized versions of Array. jhrg 8/14/15

Returns
  A pointer to the data buffer for Vectors/Arrays of the cardinal types.

Definition at line 144 of file Vector.h.

## get_compound_buf()

vector< BaseType * > & libdap::Vector::get_compound_buf | ( |  | ) |

inline inherited

Provide access to internal data by reference. Callers cannot delete this but can pass them to other methods.

Returns
  A reference to a vector of BaseType pointers. Treat with care; never delete these!

Definition at line 161 of file Vector.h.

## get_dio_flag()

bool libdap::Array::get_dio_flag | ( |  | ) | const

inline

Definition at line 324 of file Array.h.

## get_parent()

BaseType * libdap::BaseType::get_parent | ( |  | ) | const

virtual inherited

Return a pointer to the Constructor or Vector which holds (contains) this variable. If this variable is at the top level, this method returns null.

Returns
  A BaseType pointer to the variable's parent.

Definition at line 636 of file BaseType.cc.

## get_str()

vector< string > & libdap::Vector::get_str | ( |  | ) |

inline inherited

Provide access to internal string data by reference. Callers cannot delete this but can pass them to other methods.

Returns
  A reference to a vector of strings

Definition at line 152 of file Vector.h.

## get_value_capacity()

unsigned int libdap::Vector::get_value_capacity | ( |  | ) | const

virtual inherited

Return the capacity of the Vector in terms of number of elements of its data type that it can currently hold (i.e. not bytes). For example, this could be the size of the _buf array in bytes / sizeof(T) for the cardinal types T, or the capacity of the d_str vector if T is string or url type.

Definition at line 1663 of file Vector.cc.

## get_value_capacity_ll()

uint64_t libdap::Vector::get_value_capacity_ll | ( |  | ) | const

virtual inherited

Definition at line 1665 of file Vector.cc.

## get_var_storage_info()

var_storage_info & libdap::Array::get_var_storage_info | ( |  | ) |

inline

Definition at line 326 of file Array.h.

## intern_data() [1/2]

void libdap::Vector::intern_data | ( |  | ) |

override virtual inherited

Read data into this variable.

Parameters

  eval | Evaluator for a constraint expression
  dmr | DMR for the whole dataset

Reimplemented from libdap::BaseType.

Definition at line 980 of file Vector.cc.

## intern_data() [2/2]

void libdap::Vector::intern_data | ( | ConstraintEvaluator & | eval,
|  | DDS & | dds
| ) |  |

override virtual inherited

read data into a variable for later use

Most uses of a variable are to either serialize its data to a stream of some sort or to read values from some stream and intern those in the variable for later use. These operations are perform by serialize() and deserialize() which follow. This function performs essentially both of these operations without actually using a stream device. The data are read using the read() method(s) and loaded into the variables directly.

This method is intended to be used by objects which transform DAP objects like the DataDDS into an ASCII CSV representation.

Note
  A DAP2-only method

Parameters

  eval | A reference to a constraint evaluator
  dds | The complete DDS to which this variable belongs

Reimplemented from libdap::BaseType.

Definition at line 658 of file Vector.cc.

## is_constructor_type()

bool libdap::BaseType::is_constructor_type | ( |  | ) | const

virtual inherited

Returns true if the instance is a constructor (i.e., Structure, Sequence or Grid) type variable.

Returns
  True if the instance is a Structure, Sequence or Grid, False otherwise.

Definition at line 358 of file BaseType.cc.

## is_dap2_grid()

bool libdap::Array::is_dap2_grid | ( |  | ) |

Definition at line 233 of file Array.cc.

## is_dap4()

virtual bool libdap::BaseType::is_dap4 | ( |  | ) | const

inline virtual inherited

Definition at line 181 of file BaseType.h.

## is_dap4_projected()

bool libdap::Array::is_dap4_projected | ( | std::vector< std::string > & | inventory | ) |

override virtual

When send_p() is true and the attributes or variables have dap4 data types then a description of the instance is added to the inventory and true is returned.

Parameters

  inventory | is a value-result parameter

Returns
  True when send_p() is true, false otherwise

Reimplemented from libdap::BaseType.

Definition at line 1353 of file Array.cc.

## is_in_selection()

bool libdap::BaseType::is_in_selection | ( |  | ) |

virtual inherited

Is this variable part of the current selection?

Does this variable appear in either the selection part or as a function argument in the current constrain expression. If this property is set (true) then implementations of the read() method should read this variable.

Note
  This method does not check, nor does it know about the semantics of, string arguments passed to functions. Those functions might include variable names in strings; they are responsible for reading those variables. See the grid (func_grid_select()) for an example.

See also
  BaseType::read()

Definition at line 600 of file BaseType.cc.

## is_simple_type()

bool libdap::BaseType::is_simple_type | ( |  | ) | const

virtual inherited

Returns true if the instance is a numeric, string or URL type variable.

Returns
  True if the instance is a scalar numeric, String or URL variable, False otherwise. Arrays (even of simple types) return False.

See also
  is_vector_type()

Definition at line 347 of file BaseType.cc.

## is_vector_type()

bool libdap::BaseType::is_vector_type | ( |  | ) | const

virtual inherited

Returns true if the instance is a vector (i.e., array) type variable.

Returns
  True if the instance is an Array, False otherwise.

Definition at line 352 of file BaseType.cc.

## length()

int libdap::Vector::length | ( |  | ) | const

inline override virtual inherited

Returns the number of elements in the vector. Note that some child classes of Vector use the length of -1 as a flag value.

Returns
  The number of elements in the vector

Deprecated:
  Use length_ll() instead

Reimplemented from libdap::BaseType.

Definition at line 210 of file Vector.h.

## length_ll()

int64_t libdap::Vector::length_ll | ( |  | ) | const

inline override virtual inherited

Get the number of elements in this Vector/Array This version of the function deprecates length() which is limited to 32-bit sizes. The field uses -1 as a sentinel value indicating that the Vector/Array holds no values yet (as opposed to zero values).

Returns
  The number of elements in this Vector/Array

Reimplemented from libdap::BaseType.

Definition at line 218 of file Vector.h.

## m_duplicate()

void libdap::BaseType::m_duplicate | ( | const BaseType & | bt | ) |

protected inherited

Perform a deep copy.

Perform a deep copy. Copies the values of bt into `*this`. Pointers are dereferenced and their values are copied into a newly allocated instance.

Parameters

  bt | The source object.

Definition at line 85 of file BaseType.cc.

## maps()

D4Maps * libdap::Array::maps | ( |  | ) |

virtual

Definition at line 889 of file Array.cc.

## name()

string libdap::BaseType::name | ( |  | ) | const

virtual inherited

Returns the name of the class instance.

Definition at line 296 of file BaseType.cc.

## operator=()

Array & libdap::Array::operator= | ( | const Array & | rhs | ) |

Definition at line 167 of file Array.cc.

## ops()

bool libdap::BaseType::ops | ( | BaseType * | b,
|  | int | op
| ) |  |

virtual inherited

Evaluate relational operators.

This method contains the relational operators used by the constraint expression evaluator in the DDS class. Each class that wants to be able to evaluate relational expressions must overload this function. The implementation in BaseType throws an InternalErr exception. The DAP library classes Byte, ..., Url provide specializations of this method. It is not meaningful for classes such as Array because relational expressions using Array are not supported.

The op argument refers to a table generated by bison from the constraint expression parser. Use statements like the following to correctly interpret its value:

    switch (op) {
        case EQUAL: return i1 == i2;
        case NOT_EQUAL: return i1 != i2;
        case GREATER: return i1 > i2;
        case GREATER_EQL: return i1 >= i2;
        case LESS: return i1 < i2;
        case LESS_EQL: return i1 <= i2;
        case REGEXP: throw Error("Regular expressions are not supported for integer values");
        default: throw Error("Unknown operator");
    }

This function is used by the constraint expression evaluator.

Parameters

  b | Compare the value of this instance with b.
  op | An integer index indicating which relational operator is implied. Choose one from the following: `EQUAL`, `NOT_EQUAL`, `GREATER`, `GREATER_EQL`, `LESS`, `LESS_EQL`, and `REGEXP`.

Returns
  The boolean value of the comparison.

See also
  BaseType::d4_ops(BaseType *, int)

Reimplemented in libdap::D4Opaque, libdap::Byte, libdap::D4Enum, libdap::Float32, libdap::Float64, libdap::Int16, libdap::Int32, libdap::Int64, libdap::Int8, libdap::Str, libdap::UInt16, libdap::UInt32, and libdap::UInt64.

Definition at line 1101 of file BaseType.cc.

## prepend_dim() [1/2]

void libdap::Array::prepend_dim | ( | D4Dimension * | dim | ) |

Definition at line 542 of file Array.cc.

## prepend_dim() [2/2]

void libdap::Array::prepend_dim | ( | int | size,
|  | const string & | name = `""`
| ) |  |

Creates a new OUTER dimension (slowest varying in rowmajor) for the array by prepending rather than appending it.

Parameters

  size | cardinality of the new dimension
  name | optional name for the new dimension

Definition at line 534 of file Array.cc.

## print_array() [1/2]

uint64_t libdap::Array::print_array | ( | FILE * | out,
|  | uint64_t | index,
|  | unsigned int | dims,
|  | uint64_t | shape[]
| ) |  |

protected

Print the value given the current constraint.

Prints the values in ASCII of the entire (constrained) array. This method Attempts to make an aesthetically pleasing display. However, it is primarily intended for debugging purposes.

Parameters

  out | Write the output to this FILE *.
  index |
  dims |
  shape |

Definition at line 1214 of file Array.cc.

## print_array() [2/2]

uint64_t libdap::Array::print_array | ( | ostream & | out,
|  | uint64_t | index,
|  | unsigned int | dims,
|  | uint64_t | shape[]
| ) |  |

protected

Print the value given the current constraint.

Prints the values in ASCII of the entire (constrained) array. This method Attempts to make an anesthetically pleasing display. However, it is primarily intended for debugging purposes.

Parameters

  out | Write the output to this ostream
  index |
  dims |
  shape |

Definition at line 1233 of file Array.cc.

## print_as_map_xml() [1/2]

void libdap::Array::print_as_map_xml | ( | FILE * | out,
|  | string | space = `" "`,
|  | bool | constrained = `false`
| ) |  |

virtual

Deprecated:

Definition at line 1112 of file Array.cc.

## print_as_map_xml() [2/2]

void libdap::Array::print_as_map_xml | ( | ostream & | out,
|  | string | space = `" "`,
|  | bool | constrained = `false`
| ) |  |

virtual

Deprecated:

Definition at line 1121 of file Array.cc.

## print_as_map_xml_writer()

void libdap::Array::print_as_map_xml_writer | ( | XMLWriter & | xml,
|  | bool | constrained
| ) |  |

virtual

Definition at line 1147 of file Array.cc.

## print_dap4()

void libdap::Array::print_dap4 | ( | XMLWriter & | xml,
|  | bool | constrained = `false`
| ) |  |

override virtual

Print the DAP4 representation of an array.

Parameters

  xml |
  constrained |

Reimplemented from libdap::BaseType.

Definition at line 987 of file Array.cc.

## print_decl() [1/2]

void libdap::Array::print_decl | ( | FILE * | out,
|  | string | space = `" "`,
|  | bool | print_semi = `true`,
|  | bool | constraint_info = `false`,
|  | bool | constrained = `false`
| ) |  |

override virtual

Prints a DDS entry for the Array.

Prints a declaration for the Array. This is what appears in a DDS. If the Array is constrained, the declaration will reflect the size of the Array once the constraint is applied.

Parameters

  out | Write the output to this FILE *.
  space | A string containing spaces to precede the declaration.
  print_semi | A boolean indicating whether to print a semi-colon after the declaration. (TRUE means `‘print a semi-colon.’')
  constraint_info | A boolean value. See `BaseType::print_decl()`.
  constrained | This argument should be TRUE if the Array is constrained, and FALSE otherwise.

Reimplemented from libdap::BaseType.

Definition at line 1044 of file Array.cc.

## print_decl() [2/2]

void libdap::Array::print_decl | ( | ostream & | out,
|  | string | space = `" "`,
|  | bool | print_semi = `true`,
|  | bool | constraint_info = `false`,
|  | bool | constrained = `false`
| ) |  |

override virtual

Prints a DDS entry for the Array.

Prints a declaration for the Array. This is what appears in a DDS. If the Array is constrained, the declaration will reflect the size of the Array once the constraint is applied.

Parameters

  out | Write the output to this ostream.
  space | A string containing spaces to precede the declaration.
  print_semi | A boolean indicating whether to print a semi-colon after the declaration. (TRUE means `‘print a semi-colon.’')
  constraint_info | A boolean value. See `BaseType::print_decl()`.
  constrained | This argument should be TRUE if the Array is constrained, and FALSE otherwise.

Reimplemented from libdap::BaseType.

Definition at line 1067 of file Array.cc.

## print_val() [1/2]

void libdap::Array::print_val | ( | FILE * | out,
|  | string | space = `""`,
|  | bool | print_decl_p = `true`
| ) |  |

override virtual

Prints the value of the variable.

Prints the value of the variable, with its declaration. This function is primarily intended for debugging DODS applications. However, it can be overloaded and used to do some useful things. Take a look at the asciival and writeval clients, both of which overload this to output the values of variables in different ways.

Parameters

  out | The output stream on which to print the value.
  space | This value is passed to the print_decl() function, and controls the leading spaces of the output.
  print_decl_p | A boolean value controlling whether the variable declaration is printed as well as the value.

Prints the value of the variable, with its declaration. This function is primarily intended for debugging DODS applications. However, it can be overloaded and used to do some useful things. Take a look at the asciival and writeval clients, both of which overload this to output the values of variables in different ways.

Parameters

  out | The output stream on which to print the value.
  space | This value is passed to the print_decl() function, and controls the leading spaces of the output.
  print_decl_p | A boolean value controlling whether the variable declaration is printed as well as the value.

Reimplemented from libdap::BaseType.

Definition at line 1277 of file Array.cc.

## print_val() [2/2]

void libdap::Array::print_val | ( | ostream & | out,
|  | string | space = `""`,
|  | bool | print_decl_p = `true`
| ) |  |

override virtual

Prints the value of the variable.

Prints the value of the variable, with its declaration. This function is primarily intended for debugging DODS applications. However, it can be overloaded and used to do some useful things. Take a look at the asciival and writeval clients, both of which overload this to output the values of variables in different ways.

Parameters

  out | The output ostream on which to print the value.
  space | This value is passed to the print_decl() function, and controls the leading spaces of the output.
  print_decl_p | A boolean value controlling whether the variable declaration is printed as well as the value.

Implements libdap::BaseType.

Definition at line 1283 of file Array.cc.

## print_xml() [1/2]

void libdap::Array::print_xml | ( | FILE * | out,
|  | string | space = `" "`,
|  | bool | constrained = `false`
| ) |  |

override virtual

Deprecated:

Reimplemented from libdap::BaseType.

Definition at line 1094 of file Array.cc.

## print_xml() [2/2]

void libdap::Array::print_xml | ( | ostream & | out,
|  | string | space = `" "`,
|  | bool | constrained = `false`
| ) |  |

override virtual

Deprecated:

Reimplemented from libdap::BaseType.

Definition at line 1103 of file Array.cc.

## print_xml_core() [1/2]

void libdap::Array::print_xml_core | ( | FILE * | out,
|  | string | space,
|  | bool | constrained,
|  | string | tag
| ) |  |

virtual

Deprecated:

Definition at line 1130 of file Array.cc.

## print_xml_core() [2/2]

void libdap::Array::print_xml_core | ( | ostream & | out,
|  | string | space,
|  | bool | constrained,
|  | string | tag
| ) |  |

virtual

Deprecated:

Definition at line 1139 of file Array.cc.

## print_xml_writer()

void libdap::Array::print_xml_writer | ( | XMLWriter & | xml,
|  | bool | constrained = `false`
| ) |  |

override virtual

Write the XML representation of this variable. This method is used to build the DDX XML response.

Parameters

  out | Destination output stream
  space | Use this to indent child declarations. Default is "".
  constrained | If true, only print this if it's part part of the current projection. Default is False.

Reimplemented from libdap::BaseType.

Definition at line 1145 of file Array.cc.

## print_xml_writer_core()

void libdap::Array::print_xml_writer_core | ( | XMLWriter & | out,
|  | bool | constrained,
|  | string | tag
| ) |  |

virtual

Definition at line 1178 of file Array.cc.

## prototype()

virtual BaseType * libdap::Vector::prototype | ( |  | ) | const

inline virtual inherited

Definition at line 163 of file Vector.h.

## ptr_duplicate()

BaseType * libdap::Array::ptr_duplicate | ( |  | ) |

override virtual

Clone this instance. Allocate a new instance and copy `*this` into it. This method must perform a deep copy.

    @note This method should \e not copy data values, but must copy all
    other fields in the object.

Returns
  A newly allocated copy of `this`.

Implements libdap::BaseType.

Definition at line 165 of file Array.cc.

## read()

bool libdap::BaseType::read | ( |  | ) |

virtual inherited

Read data into a local buffer.

This method should be implemented for each of the data type classes (Byte, ..., Grid) when using the DAP class library to build a server. This method is only for DAP servers. The library provides a default definition here which throws an InternalErr exception unless the read_p property has been set. In that case it returns false, indicating that all the data have been read. The latter case can happen when building a constant value that needs to be passed to a function. The variable/constant is loaded with a value when it is created.

When implementing a new DAP server, the Byte, ..., Grid data type classes are usually specialized. In each of those specializations read() should be defined to read values from the data source and store them in the object's local buffer. The read() method is called by other methods in this library. When writing read(), follow these rules:

- read() should throw Error if it encounters an error. The message should be verbose enough to be understood by someone running a client on a different machine.
- The value(s) should be read if and only if either send_p() or is_in_selection() return true. If neither of these return true, the value(s) should not be read. This is important when writing read() for a Constructor type such as Grid where a client may ask for only the map vectors (and thus reading the much larger Array part is not needed).
- For each specialization of read(), the method should first test the value of the `read_p` property (using the read_p() method) and read values only if the value of read_p() is false. Once the read() method reads data and stores it in the instance, it must set the value of the `read_p` property to true using set_read_p(). If your read() methods fail to do this data may not serialize correctly.
- The Array::read() and Grid::read() methods should take into account any restrictions on Array sizes.
- If you are writing Sequence::read(), be sure to check the documentation for Sequence::read_row() and Sequence::serialize() so you understand how Sequence::read() is being called.

- For Sequence::read(), your specialization must correctly manage the `unsent_data` property and row count in addition to the `read_p` property (handle the `read_p` property as describe above). For a Sequence to serialize correctly, once all data from the Sequence has been read, `unsent_data` property must be set to false (use Sequence::set_unsent_data()). Also, at that time the row number counter must be reset (use Sequence::reset_row_counter()). Typically the correct time to set `unsent_data` to false and reset the row counter is the time when Sequence::read() return false indicating that all the data for the Sequence have been read. Failure to handle these tasks will break serialization of nested Sequences. Note that when Sequence::read() returns with a result of true (indicating there is more data to send, the value of the `unsent_data` property should be true.

  Also, if you server must handle nested sequences, be sure to read about subclassing set_read_p().

Todo:
  Modify the D4 serialize code so that it supports the true/false behavior of read() for arrays.

Todo:
  Modify all of the stock handlers so they conform to this!

Returns
  False means more data remains to be read, True indicates that no more data need to be read. For Sequence and D4Sequence, this method will generally read one instance of the Sequence; for other types it will generally read the entire variable modulo any limitations due to a constraint. However, the library should be written so that read can return less than all of the data for a variable - serialize() would then call the function until it returns True.

See also
  BaseType

Reimplemented in libdap::Constructor.

Definition at line 775 of file BaseType.cc.

## read_p()

bool libdap::BaseType::read_p | ( |  | ) |

virtual inherited

Has this variable been read?

Returns true if the value(s) for this variable have been read from the data source, otherwise returns false. This method is used to determine when values need to be read using the read() method. When read_p() returns true, this library assumes that buf2val() (and other methods such as get_vec()) can be used to access the value(s) of a variable.

Returns
  True if the variable's value(s) have been read, false otherwise.

Definition at line 410 of file BaseType.cc.

## rename_dim()

void libdap::Array::rename_dim | ( | const string & | oldName = `""`,
|  | const string & | newName = `""`
| ) |  |

Renames dimension.

Renames dimension to a new name

Definition at line 560 of file Array.cc.

## reserve_value_capacity() [1/2]

void libdap::Vector::reserve_value_capacity | ( |  | ) |

virtual inherited

Make sure there's storage allocated for the current length() of the Vector. Same as reserveValueCapacity(length())

Definition at line 1735 of file Vector.cc.

## reserve_value_capacity() [2/2]

void libdap::Vector::reserve_value_capacity | ( | unsigned int | numElements | ) |

virtual inherited

Allocate enough memory for the Vector to contain numElements data elements of the Vector's type. Must be used before set_value_slice_from_row_major_vector to ensure memory exists.

Parameters

  numElements | the number of elements of the Vector's type to preallocate storage for.

Exceptions

  if | the memory cannot be allocated

Definition at line 1675 of file Vector.cc.

## reserve_value_capacity_ll() [1/2]

void libdap::Vector::reserve_value_capacity_ll | ( |  | ) |

virtual inherited

Make sure there's storage allocated for the current length() of the Vector. Same as reserveValueCapacity(length())

Definition at line 1808 of file Vector.cc.

## reserve_value_capacity_ll() [2/2]

void libdap::Vector::reserve_value_capacity_ll | ( | uint64_t | numElements | ) |

virtual inherited

Allocate enough memory for the Vector to contain numElements data elements of the Vector's type. Must be used before set_value_slice_from_row_major_vector to ensure memory exists.

Parameters

  numElements | the number of elements of the Vector's type to preallocate storage for.

Exceptions

  if | the memory cannot be allocated

Definition at line 1748 of file Vector.cc.

## reserve_value_capacity_ll_byte()

void libdap::Vector::reserve_value_capacity_ll_byte | ( | uint64_t | numBytes | ) |

virtual inherited

A light-weight method to allocate the storage size in bytes of the Vector. This method is necessary for operations like direct IO in the BES.

Definition at line 1818 of file Vector.cc.

## reset_constraint()

void libdap::Array::reset_constraint | ( |  | ) |

virtual

Reset constraint to select entire array.

Resets the dimension constraint information so that the entire array is selected.

Definition at line 578 of file Array.cc.

## send_p()

bool libdap::BaseType::send_p | ( |  | ) |

virtual inherited

Should this variable be sent?

Returns the state of the `send_p` property. If true, this variable should be sent to the client, if false, it should not. If no constraint expression (CE) has been evaluated, this property is true for all variables in a data source (i.e., for all the variables listed in a DDS). If a CE has been evaluated, this property is true only for those variables listed in the projection part of the CE.

Returns
  True if the variable should be sent to the client, false otherwise.

Definition at line 478 of file BaseType.cc.

## serialize() [1/2]

bool libdap::Vector::serialize | ( | ConstraintEvaluator & | eval,
|  | DDS & | dds,
|  | Marshaller & | m,
|  | bool | ce_eval = `true`
| ) |  |

override virtual inherited

Serialize a Vector.

This uses the Marshaller class to encode each element of a cardinal array. For Arrays of Str and Url types, send the element count over as a prefix to the data so that deserialize will know how many elements to read.

NB: Arrays of cardinal types must already be in BUF (in the local machine's representation) before this call is made.

Reimplemented from libdap::BaseType.

Definition at line 726 of file Vector.cc.

## serialize() [2/2]

void libdap::Vector::serialize | ( | D4StreamMarshaller & | m,
|  | DMR & | dmr,
|  | bool | filter = `false`
| ) |  |

override virtual inherited

The DAP4 serialization method. Serialize a variable's values for DAP4. This does not write the DMR persistent representation but does write that part of the binary data blob that holds a variable's data. Once a variable's data are serialized, that memory is reclaimed (by calling BaseType::clear_local_data())

Parameters

  m |
  dmr |
  eval |
  filter | True if there is one variable that should be 'filtered'

Exceptions

  Error | or InternalErr

Reimplemented from libdap::BaseType.

Definition at line 1026 of file Vector.cc.

## set_attr_table()

void libdap::BaseType::set_attr_table | ( | const AttrTable & | at | ) |

virtual inherited

Set this variable's attribute table.

Parameters

  at | Source of the attributes.

Definition at line 502 of file BaseType.cc.

## set_attributes()

void libdap::BaseType::set_attributes | ( | D4Attributes * | attrs | ) |

virtual inherited

Definition at line 513 of file BaseType.cc.

## set_attributes_nocopy()

void libdap::BaseType::set_attributes_nocopy | ( | D4Attributes * | attrs | ) |

virtual inherited

Definition at line 515 of file BaseType.cc.

## set_dio_flag()

void libdap::Array::set_dio_flag | ( | bool | dio_flag_value = `true` | ) |

inline

Definition at line 325 of file Array.h.

## set_in_selection()

void libdap::BaseType::set_in_selection | ( | bool | state | ) |

virtual inherited

Set the in_selection property to state. This property indicates that the variable is used as a parameter to a constraint expression function or that it appears as an argument in a selection sub-expression. If set (true), implementations of the BaseType::read() method should read this variable.

Parameters

  state | Set the in_selection property to this state.

See also
  BaseType::read()
  BaseType::is_in_selection() for more information.

Reimplemented in libdap::Constructor.

Definition at line 611 of file BaseType.cc.

## set_is_dap4()

virtual void libdap::BaseType::set_is_dap4 | ( | const bool | v | ) |

inline virtual inherited

Definition at line 182 of file BaseType.h.

## set_length()

void libdap::Vector::set_length | ( | int64_t | l | ) |

override virtual inherited

Sets the length of the vector. This function does not allocate any new space.

This updated version can accept sizes that are too big for a DAP2 Array, but if that happens, a flag is set.

Parameters

  l | The number of elements

Deprecated:
  Use set_length_ll() instead

Reimplemented from libdap::BaseType.

Definition at line 423 of file Vector.cc.

## set_length_ll()

void libdap::Vector::set_length_ll | ( | int64_t | l | ) |

override virtual inherited

Set the number of elements in this Vector/Array This version of the function deprecates set_length() which is limited to 32-bit sizes. The field uses -1 as a sentinel value indicating that the Vector/Array holds no values.

Parameters

  l | The number of elements in the Vector/Array

Reimplemented from libdap::BaseType.

Definition at line 432 of file Vector.cc.

## set_name()

void libdap::Vector::set_name | ( | const std::string & | n | ) |

override virtual inherited

Sets the name of the class instance.

Reimplemented from libdap::BaseType.

Definition at line 323 of file Vector.cc.

## set_parent()

void libdap::BaseType::set_parent | ( | BaseType * | parent | ) |

virtual inherited

Set the `parent` property for this variable.

Note
  Added ability to set parent to null. 10/19/12 jhrg

Parameters

  parent | Pointer to the Constructor of Vector parent variable or null if the variable has no parent (if it is at the top-level of a DAP2/3 DDS).

Exceptions

  InternalErr | thrown if called with anything other than a Constructor, Vector or Null.

Definition at line 622 of file BaseType.cc.

## set_prototype()

virtual BaseType * libdap::Vector::set_prototype | ( | BaseType * | btp | ) |

inline virtual inherited

Change the Vector/Array element type.

Parameters

  btp |

Returns
  The previous template, calling code is responsible for the returned BaseType lifecycle.

Definition at line 170 of file Vector.h.

## set_read_p()

void libdap::Vector::set_read_p | ( | bool | state | ) |

override virtual inherited

Indicates that the data is ready to send.

This function sets the `read_p` flag for both the Vector itself and its element template. This does not matter much when the Vector contains simple data types, but does become significant when the Vector contains compound types.

Reimplemented from libdap::BaseType.

Definition at line 389 of file Vector.cc.

## set_send_p()

void libdap::Vector::set_send_p | ( | bool | state | ) |

override virtual inherited

Indicates that the data is ready to send.

This function sets the `send_p` flag for both the Vector itself and its element template. This does not matter much when the Vector contains simple data types, but does become significant when the Vector contains compound types.

Reimplemented from libdap::BaseType.

Definition at line 352 of file Vector.cc.

## set_synthesized_p()

void libdap::BaseType::set_synthesized_p | ( | bool | state | ) |

virtual inherited

Set the synthesized flag. Before setting this flag be sure to set the `read_p()` state. Once this flag is set you cannot alter the state of the `read_p` flag!

See also
  synthesized_p()

Definition at line 397 of file BaseType.cc.

## set_type()

void libdap::BaseType::set_type | ( | const Type & | t | ) |

virtual inherited

Sets the type of the class instance.

Definition at line 332 of file BaseType.cc.

## set_value() [1/22]

bool libdap::Vector::set_value | ( | dods_byte * | val,
|  | int | sz
| ) |  |

virtual inherited

Definition at line 2017 of file Vector.cc.

## set_value() [2/22]

bool libdap::Vector::set_value | ( | dods_float32 * | val,
|  | int | sz
| ) |  |

virtual inherited

Definition at line 2026 of file Vector.cc.

## set_value() [3/22]

bool libdap::Vector::set_value | ( | dods_float64 * | val,
|  | int | sz
| ) |  |

virtual inherited

Definition at line 2027 of file Vector.cc.

## set_value() [4/22]

bool libdap::Vector::set_value | ( | dods_int16 * | val,
|  | int | sz
| ) |  |

virtual inherited

Definition at line 2020 of file Vector.cc.

## set_value() [5/22]

bool libdap::Vector::set_value | ( | dods_int32 * | val,
|  | int | sz
| ) |  |

virtual inherited

Definition at line 2022 of file Vector.cc.

## set_value() [6/22]

bool libdap::Vector::set_value | ( | dods_int64 * | val,
|  | int | sz
| ) |  |

virtual inherited

Definition at line 2024 of file Vector.cc.

## set_value() [7/22]

bool libdap::Vector::set_value | ( | dods_int8 * | val,
|  | int | sz
| ) |  |

virtual inherited

Definition at line 2019 of file Vector.cc.

## set_value() [8/22]

bool libdap::Vector::set_value | ( | dods_uint16 * | val,
|  | int | sz
| ) |  |

virtual inherited

Definition at line 2021 of file Vector.cc.

## set_value() [9/22]

bool libdap::Vector::set_value | ( | dods_uint32 * | val,
|  | int | sz
| ) |  |

virtual inherited

Definition at line 2023 of file Vector.cc.

## set_value() [10/22]

bool libdap::Vector::set_value | ( | dods_uint64 * | val,
|  | int | sz
| ) |  |

virtual inherited

Definition at line 2025 of file Vector.cc.

## set_value() [11/22]

bool libdap::Vector::set_value | ( | string * | val,
|  | int | sz
| ) |  |

virtual inherited

set the value of a string or url array

Parameters

  val | An array of string objects
  sz | The number of elements in the string array

Returns
  false if the type of the array is neither Str nor Url or val is null, otherwise returns true.

Definition at line 2048 of file Vector.cc.

## set_value() [12/22]

bool libdap::Vector::set_value | ( | vector< dods_byte > & | val,
|  | int | sz
| ) |  |

virtual inherited

Definition at line 2088 of file Vector.cc.

## set_value() [13/22]

bool libdap::Vector::set_value | ( | vector< dods_float32 > & | val,
|  | int | sz
| ) |  |

virtual inherited

Definition at line 2096 of file Vector.cc.

## set_value() [14/22]

bool libdap::Vector::set_value | ( | vector< dods_float64 > & | val,
|  | int | sz
| ) |  |

virtual inherited

Definition at line 2097 of file Vector.cc.

## set_value() [15/22]

bool libdap::Vector::set_value | ( | vector< dods_int16 > & | val,
|  | int | sz
| ) |  |

virtual inherited

Definition at line 2090 of file Vector.cc.

## set_value() [16/22]

bool libdap::Vector::set_value | ( | vector< dods_int32 > & | val,
|  | int | sz
| ) |  |

virtual inherited

Definition at line 2092 of file Vector.cc.

## set_value() [17/22]

bool libdap::Vector::set_value | ( | vector< dods_int64 > & | val,
|  | int | sz
| ) |  |

virtual inherited

Definition at line 2094 of file Vector.cc.

## set_value() [18/22]

bool libdap::Vector::set_value | ( | vector< dods_int8 > & | val,
|  | int | sz
| ) |  |

virtual inherited

Definition at line 2089 of file Vector.cc.

## set_value() [19/22]

bool libdap::Vector::set_value | ( | vector< dods_uint16 > & | val,
|  | int | sz
| ) |  |

virtual inherited

Definition at line 2091 of file Vector.cc.

## set_value() [20/22]

bool libdap::Vector::set_value | ( | vector< dods_uint32 > & | val,
|  | int | sz
| ) |  |

virtual inherited

Definition at line 2093 of file Vector.cc.

## set_value() [21/22]

bool libdap::Vector::set_value | ( | vector< dods_uint64 > & | val,
|  | int | sz
| ) |  |

virtual inherited

Definition at line 2095 of file Vector.cc.

## set_value() [22/22]

bool libdap::Vector::set_value | ( | vector< string > & | val,
|  | int | sz
| ) |  |

virtual inherited

set the value of a string or url array

Definition at line 2111 of file Vector.cc.

## set_value_capacity()

void libdap::Vector::set_value_capacity | ( | uint64_t | l | ) |

inherited

Definition at line 442 of file Vector.cc.

## set_value_ll() [1/22]

bool libdap::Vector::set_value_ll | ( | dods_byte * | val,
|  | int64_t | sz
| ) |  |

virtual inherited

Definition at line 2029 of file Vector.cc.

## set_value_ll() [2/22]

bool libdap::Vector::set_value_ll | ( | dods_float32 * | val,
|  | int64_t | sz
| ) |  |

virtual inherited

Definition at line 2038 of file Vector.cc.

## set_value_ll() [3/22]

bool libdap::Vector::set_value_ll | ( | dods_float64 * | val,
|  | int64_t | sz
| ) |  |

virtual inherited

Definition at line 2039 of file Vector.cc.

## set_value_ll() [4/22]

bool libdap::Vector::set_value_ll | ( | dods_int16 * | val,
|  | int64_t | sz
| ) |  |

virtual inherited

Definition at line 2032 of file Vector.cc.

## set_value_ll() [5/22]

bool libdap::Vector::set_value_ll | ( | dods_int32 * | val,
|  | int64_t | sz
| ) |  |

virtual inherited

Definition at line 2034 of file Vector.cc.

## set_value_ll() [6/22]

bool libdap::Vector::set_value_ll | ( | dods_int64 * | val,
|  | int64_t | sz
| ) |  |

virtual inherited

Definition at line 2036 of file Vector.cc.

## set_value_ll() [7/22]

bool libdap::Vector::set_value_ll | ( | dods_int8 * | val,
|  | int64_t | sz
| ) |  |

virtual inherited

Definition at line 2031 of file Vector.cc.

## set_value_ll() [8/22]

bool libdap::Vector::set_value_ll | ( | dods_uint16 * | val,
|  | int64_t | sz
| ) |  |

virtual inherited

Definition at line 2033 of file Vector.cc.

## set_value_ll() [9/22]

bool libdap::Vector::set_value_ll | ( | dods_uint32 * | val,
|  | int64_t | sz
| ) |  |

virtual inherited

Definition at line 2035 of file Vector.cc.

## set_value_ll() [10/22]

bool libdap::Vector::set_value_ll | ( | dods_uint64 * | val,
|  | int64_t | sz
| ) |  |

virtual inherited

Definition at line 2037 of file Vector.cc.

## set_value_ll() [11/22]

bool libdap::Vector::set_value_ll | ( | string * | val,
|  | int64_t | sz
| ) |  |

virtual inherited

Definition at line 2066 of file Vector.cc.

## set_value_ll() [12/22]

bool libdap::Vector::set_value_ll | ( | vector< dods_byte > & | val,
|  | int64_t | sz
| ) |  |

virtual inherited

Definition at line 2099 of file Vector.cc.

## set_value_ll() [13/22]

bool libdap::Vector::set_value_ll | ( | vector< dods_float32 > & | val,
|  | int64_t | sz
| ) |  |

virtual inherited

Definition at line 2107 of file Vector.cc.

## set_value_ll() [14/22]

bool libdap::Vector::set_value_ll | ( | vector< dods_float64 > & | val,
|  | int64_t | sz
| ) |  |

virtual inherited

Definition at line 2108 of file Vector.cc.

## set_value_ll() [15/22]

bool libdap::Vector::set_value_ll | ( | vector< dods_int16 > & | val,
|  | int64_t | sz
| ) |  |

virtual inherited

Definition at line 2101 of file Vector.cc.

## set_value_ll() [16/22]

bool libdap::Vector::set_value_ll | ( | vector< dods_int32 > & | val,
|  | int64_t | sz
| ) |  |

virtual inherited

Definition at line 2103 of file Vector.cc.

## set_value_ll() [17/22]

bool libdap::Vector::set_value_ll | ( | vector< dods_int64 > & | val,
|  | int64_t | sz
| ) |  |

virtual inherited

Definition at line 2105 of file Vector.cc.

## set_value_ll() [18/22]

bool libdap::Vector::set_value_ll | ( | vector< dods_int8 > & | val,
|  | int64_t | sz
| ) |  |

virtual inherited

Definition at line 2100 of file Vector.cc.

## set_value_ll() [19/22]

bool libdap::Vector::set_value_ll | ( | vector< dods_uint16 > & | val,
|  | int64_t | sz
| ) |  |

virtual inherited

Definition at line 2102 of file Vector.cc.

## set_value_ll() [20/22]

bool libdap::Vector::set_value_ll | ( | vector< dods_uint32 > & | val,
|  | int64_t | sz
| ) |  |

virtual inherited

Definition at line 2104 of file Vector.cc.

## set_value_ll() [21/22]

bool libdap::Vector::set_value_ll | ( | vector< dods_uint64 > & | val,
|  | int64_t | sz
| ) |  |

virtual inherited

Definition at line 2106 of file Vector.cc.

## set_value_ll() [22/22]

bool libdap::Vector::set_value_ll | ( | vector< string > & | val,
|  | int64_t | sz
| ) |  |

virtual inherited

Definition at line 2126 of file Vector.cc.

## set_value_slice_from_row_major_vector()

uint64_t libdap::Vector::set_value_slice_from_row_major_vector | ( | const Vector & | rowMajorDataC,
|  | uint64_t | startElement
| ) |  |

virtual inherited

Copy rowMajorData.length() elements currently in a rowMajorData buffer into this value buffer starting at element index startElement and continuing up to startElement+rowMajorData.length()-1

This is used for aggregating together smaller rowMajor vectors into a larger one.

Note: unlike the other set_value calls, this does NOT set read_p() since it is assumed to be used as a partial read and the caller is expected to set_read_p() when the data is complete.

ASSUMES: rowMajorData.read_p() so that the data is valid! ASSUMES: this Vector has enough value_capacity() to contain all the elements such that: startElement + rowMajorData.length() <= this->value_capacity(). ASSUMES: the data type of this->var() and rowMajorData.var() MUST be non-NULL and be the same!

Parameters

  rowMajorDataC | the vector from which to copy data, assumed already read in or set.
  startElement | the element index (NOT byte, but rather data type element) to place the first data value.

Returns
  the number of elements added, such that: startElement + the return value is the next "free" element.

Definition at line 1847 of file Vector.cc.

## set_var_storage_info()

void libdap::Array::set_var_storage_info | ( | const var_storage_info & | my_vs_info | ) |

Set the variable storage information for direct IO optimization.

Parameters

  the | struct that stores the variable storage information.

Returns
  void

Definition at line 1409 of file Array.cc.

## set_vec()

void libdap::Vector::set_vec | ( | unsigned int | i,
|  | BaseType * | val
| ) |  |

inherited

Sets element i to value val.

Sets an element of the vector to a given value. If the type of the input and the type of the Vector do not match, an error condition is returned.

Use this function only with Vectors containing compound types. See `buf2val()` or the `set_value()` methods to access members of Vector containing simple types.

Note
  This method copies val; the caller is responsible for deleting instance passed as the actual parameter.

Returns
  void

Exceptions

  InternalErr | Thrown if i is out of range, val is null or there was a type mismatch between the BaseType referenced by val and the ith element of this Vector.

Parameters

  i | The index of the element to be changed.
  val | A pointer to the value to be inserted into the array.

See also
  Vector::buf2val

Definition at line 1556 of file Vector.cc.

## set_vec_ll()

void libdap::Vector::set_vec_ll | ( | uint64_t | i,
|  | BaseType * | val
| ) |  |

inherited

Definition at line 1558 of file Vector.cc.

## set_vec_nocopy()

void libdap::Vector::set_vec_nocopy | ( | unsigned int | i,
|  | BaseType * | val
| ) |  |

inherited

Sets element i to value val. Set the ith element to val. Extend the vector if needed.

Note
  It is best to call vec_resize() first and allocate enough elements before calling this method.
  This method does not copy val; this class will free the instance when the variable is deleted or when clear_local_data() is called.

See also
  Vector::set_vec()

Definition at line 1571 of file Vector.cc.

## set_vec_nocopy_ll()

void libdap::Vector::set_vec_nocopy_ll | ( | uint64_t | i,
|  | BaseType * | val
| ) |  |

inherited

Definition at line 1599 of file Vector.cc.

## shape()

std::vector< dimension > & libdap::Array::shape | ( |  | ) |

inline protected

Definition at line 219 of file Array.h.

## synthesized_p()

bool libdap::BaseType::synthesized_p | ( |  | ) |

virtual inherited

Returns true if the variable is a synthesized variable. A synthesized variable is one that is added to the dataset by the server (usually with a ‘projection function’.

Definition at line 390 of file BaseType.cc.

## toString()

string libdap::BaseType::toString | ( |  | ) |

virtual inherited

Write out the object's internal fields in a string. To be used for debugging when regular inspection w/ddd or gdb isn't enough.

Returns
  A string which shows the object's internal stuff.

Reimplemented in libdap::Sequence.

Definition at line 170 of file BaseType.cc.

## transfer_attributes()

void libdap::BaseType::transfer_attributes | ( | AttrTable * | at_container | ) |

virtual inherited

Transfer attributes from a DAS object into this variable. Because of the rough history of the DAS object and the way that various server code built the DAS, this is necessarily a heuristic process. The intent is that this method will be overridden by handlers that need to look for certain patterns in the DAS (e.g., hdf4's odd variable_dim_n; where n = 0, 1, 2, ...) attribute containers.

There should be a one-to-one mapping between variables and attribute containers. However, in some cases one variable has attributes spread across several top level containers and in some cases one container is used by several variables

Note
  This method is technically unnecessary because a server (or client) can easily add attributes directly using the DDS::get_attr_table or BaseType::get_attr_table methods and then poke values in using any of the methods AttrTable provides. This method exists to ease the transition to DDS objects which contain attribute information for the existing servers (Since they all make DAS objects separately from the DDS). They could be modified to use the same AttrTable methods but operate on the AttrTable instances in a DDS/BaseType instead of those in a DAS.

Parameters

  at_container | Transfer attributes from this container.

Returns
  void

Reimplemented in libdap::Constructor, and libdap::Grid.

Definition at line 544 of file BaseType.cc.

## transform_to_dap2()

std::vector< BaseType * > * libdap::Array::transform_to_dap2 | ( | AttrTable * | parent_attr_table | ) |

override virtual

Transforms this instance of a D4Array into the corresponding DAP2 object.

This transformation may return an Array or a Grid object. The DAP2 Grid construct is semantically contained in the DAP4 concept of arrays with Map arrays. If all of the Maps are one dimensional then the D4Array can be represented as a Grid object.

Parameters

  The | AttrTable pointer parent_attr_table is used by Groups, which disappear from the DAP2 representation. Their children are returned in the the BAseType vector their attributes are added to parent_attr_table.

Returns
  A pointer to a vector of BaseType pointers (right?). In this D4Array case returned vector may contain a DAP2 Array or a Grid. Or, if the Array' prototype is a type that cannot be represented in DAP2 the return will be NULL.

Reimplemented from libdap::BaseType.

Definition at line 287 of file Array.cc.

## transform_to_dap4()

void libdap::Array::transform_to_dap4 | ( | D4Group * | root,
|  | Constructor * | container
| ) |  |

override virtual

DAP2 to DAP4 transform.

For the current BaseType, return a DAP4 'copy' of the variable.

Note
  For most DAP2 types, in this implementation of DAP4 the corresponding DAP4 type is the same. The different types are Sequences (which are D4Sequences in the DAP4 implementation), Grids (which are coverages) and Arrays (which use shared dimensions).

Parameters

  root | The root group that should hold this new variable. Add Group-level stuff here (e.g., D4Dimensions).
  container | Add the new variable to this container.

Returns
  A pointer to the transformed variable

Reimplemented from libdap::BaseType.

Definition at line 175 of file Array.cc.

## type()

Type libdap::BaseType::type | ( |  | ) | const

virtual inherited

Returns the type of the class instance.

Definition at line 329 of file BaseType.cc.

## type_name()

string libdap::BaseType::type_name | ( |  | ) | const

virtual inherited

Returns the type of the class instance as a string.

Definition at line 335 of file BaseType.cc.

## update_length()

void libdap::Array::update_length | ( | int | size = `0` | ) |

virtual

Deprecated:
  Calling this method should never be necessary. It is used internally and called whenever the size of the Array is changed, e.g., by a constraint.

Changes the length property of the array.

Definition at line 98 of file Array.cc.

## update_length_ll()

void libdap::Array::update_length_ll | ( | unsigned long long | size = `0` | ) |

virtual

Definition at line 107 of file Array.cc.

## val2buf()

unsigned int libdap::Vector::val2buf | ( | void * | val,
|  | bool | reuse = `false`
| ) |  |

override virtual inherited

Reads data into the Vector buffer.

Copies data into the class instance buffer. This function assumes that the input val points to memory which contains, in row major order, enough elements of the correct type to fill the array. For an array of a cardinal type the memory is simply copied in whole into the Vector buffer.

If the variable has already been constrained, this method will load only number of values/bytes specified by that constraint and will load them into the 'front' of the object's internal buffer. This is where serialize() expects to find the data.

For a Vector of Str (OPeNDAP Strings), this assumes val points to an array of C++ strings.

This method should not be used for Structure, Sequence or Grid.

Exceptions

  InternalErr | Thrown if called for Structure, Sequence or Grid.

Returns
  The number of bytes used by the array.

Parameters

  val | A pointer to the input data.
  reuse | A boolean value, indicating whether the class internal data storage can be reused or not. If this argument is TRUE, the class buffer is assumed to be large enough to hold the incoming data, and it is not reallocated. If FALSE, new storage is allocated. If the internal buffer has not been allocated at all, this argument has no effect.

Implements libdap::BaseType.

Definition at line 1303 of file Vector.cc.

## val2buf_ll()

int64_t libdap::Vector::val2buf_ll | ( | void * | val,
|  | bool | reuse = `false`
| ) |  |

inherited

Definition at line 1309 of file Vector.cc.

## value() [1/23]

void * libdap::Vector::value | ( |  | ) |

virtual inherited

Allocate memory and copy data into the new buffer. Return the new buffer's pointer. The caller must delete the storage.

Definition at line 2327 of file Vector.cc.

## value() [2/23]

void libdap::Vector::value | ( | dods_byte * | b | ) | const

virtual inherited

Definition at line 2295 of file Vector.cc.

## value() [3/23]

void libdap::Vector::value | ( | dods_float32 * | b | ) | const

virtual inherited

Definition at line 2303 of file Vector.cc.

## value() [4/23]

void libdap::Vector::value | ( | dods_float64 * | b | ) | const

virtual inherited

Definition at line 2304 of file Vector.cc.

## value() [5/23]

void libdap::Vector::value | ( | dods_int16 * | b | ) | const

virtual inherited

Definition at line 2297 of file Vector.cc.

## value() [6/23]

void libdap::Vector::value | ( | dods_int32 * | b | ) | const

virtual inherited

Definition at line 2299 of file Vector.cc.

## value() [7/23]

void libdap::Vector::value | ( | dods_int64 * | b | ) | const

virtual inherited

Definition at line 2301 of file Vector.cc.

## value() [8/23]

void libdap::Vector::value | ( | dods_int8 * | b | ) | const

virtual inherited

Definition at line 2296 of file Vector.cc.

## value() [9/23]

void libdap::Vector::value | ( | dods_uint16 * | b | ) | const

virtual inherited

Definition at line 2298 of file Vector.cc.

## value() [10/23]

void libdap::Vector::value | ( | dods_uint32 * | b | ) | const

virtual inherited

Definition at line 2300 of file Vector.cc.

## value() [11/23]

void libdap::Vector::value | ( | dods_uint64 * | b | ) | const

virtual inherited

Definition at line 2302 of file Vector.cc.

## value() [12/23]

void libdap::Vector::value | ( | vector< string > & | b | ) | const

virtual inherited

Get a copy of the data held by this variable.

Definition at line 2320 of file Vector.cc.

## value() [13/23]

void libdap::Vector::value | ( | vector< unsigned int > * | index,
|  | vector< string > & | b
| ) |  | const

virtual inherited

Get a copy of the data held by this variable using the passed subsetIndex vector to identify which values to return.

Definition at line 2252 of file Vector.cc.

## value() [14/23]

void libdap::Vector::value | ( | vector< unsigned int > * | indices,
|  | dods_byte * | b
| ) |  | const

virtual inherited

Definition at line 2215 of file Vector.cc.

## value() [15/23]

void libdap::Vector::value | ( | vector< unsigned int > * | indices,
|  | dods_float32 * | b
| ) |  | const

virtual inherited

Definition at line 2223 of file Vector.cc.

## value() [16/23]

void libdap::Vector::value | ( | vector< unsigned int > * | indices,
|  | dods_float64 * | b
| ) |  | const

virtual inherited

Definition at line 2224 of file Vector.cc.

## value() [17/23]

void libdap::Vector::value | ( | vector< unsigned int > * | indices,
|  | dods_int16 * | b
| ) |  | const

virtual inherited

Definition at line 2217 of file Vector.cc.

## value() [18/23]

void libdap::Vector::value | ( | vector< unsigned int > * | indices,
|  | dods_int32 * | b
| ) |  | const

virtual inherited

Definition at line 2219 of file Vector.cc.

## value() [19/23]

void libdap::Vector::value | ( | vector< unsigned int > * | indices,
|  | dods_int64 * | b
| ) |  | const

virtual inherited

Definition at line 2221 of file Vector.cc.

## value() [20/23]

void libdap::Vector::value | ( | vector< unsigned int > * | indices,
|  | dods_int8 * | b
| ) |  | const

virtual inherited

Definition at line 2216 of file Vector.cc.

## value() [21/23]

void libdap::Vector::value | ( | vector< unsigned int > * | indices,
|  | dods_uint16 * | b
| ) |  | const

virtual inherited

Definition at line 2218 of file Vector.cc.

## value() [22/23]

void libdap::Vector::value | ( | vector< unsigned int > * | indices,
|  | dods_uint32 * | b
| ) |  | const

virtual inherited

Definition at line 2220 of file Vector.cc.

## value() [23/23]

void libdap::Vector::value | ( | vector< unsigned int > * | indices,
|  | dods_uint64 * | b
| ) |  | const

virtual inherited

Definition at line 2222 of file Vector.cc.

## value_ll() [1/11]

void libdap::Vector::value_ll | ( | vector< uint64_t > * | index,
|  | vector< string > & | b
| ) |  | const

virtual inherited

Definition at line 2270 of file Vector.cc.

## value_ll() [2/11]

void libdap::Vector::value_ll | ( | vector< uint64_t > * | indices,
|  | dods_byte * | b
| ) |  | const

virtual inherited

Definition at line 2226 of file Vector.cc.

## value_ll() [3/11]

void libdap::Vector::value_ll | ( | vector< uint64_t > * | indices,
|  | dods_float32 * | b
| ) |  | const

virtual inherited

Definition at line 2234 of file Vector.cc.

## value_ll() [4/11]

void libdap::Vector::value_ll | ( | vector< uint64_t > * | indices,
|  | dods_float64 * | b
| ) |  | const

virtual inherited

Definition at line 2235 of file Vector.cc.

## value_ll() [5/11]

void libdap::Vector::value_ll | ( | vector< uint64_t > * | indices,
|  | dods_int16 * | b
| ) |  | const

virtual inherited

Definition at line 2228 of file Vector.cc.

## value_ll() [6/11]

void libdap::Vector::value_ll | ( | vector< uint64_t > * | indices,
|  | dods_int32 * | b
| ) |  | const

virtual inherited

Definition at line 2230 of file Vector.cc.

## value_ll() [7/11]

void libdap::Vector::value_ll | ( | vector< uint64_t > * | indices,
|  | dods_int64 * | b
| ) |  | const

virtual inherited

Definition at line 2232 of file Vector.cc.

## value_ll() [8/11]

void libdap::Vector::value_ll | ( | vector< uint64_t > * | indices,
|  | dods_int8 * | b
| ) |  | const

virtual inherited

Definition at line 2227 of file Vector.cc.

## value_ll() [9/11]

void libdap::Vector::value_ll | ( | vector< uint64_t > * | indices,
|  | dods_uint16 * | b
| ) |  | const

virtual inherited

Definition at line 2229 of file Vector.cc.

## value_ll() [10/11]

void libdap::Vector::value_ll | ( | vector< uint64_t > * | indices,
|  | dods_uint32 * | b
| ) |  | const

virtual inherited

Definition at line 2231 of file Vector.cc.

## value_ll() [11/11]

void libdap::Vector::value_ll | ( | vector< uint64_t > * | indices,
|  | dods_uint64 * | b
| ) |  | const

virtual inherited

Definition at line 2233 of file Vector.cc.

## var() [1/3]

BaseType * libdap::Vector::var | ( | const string & | n,
|  | btp_stack & | s
| ) |  |

override virtual inherited

This version of var(...) searches for name and returns a pointer to the BaseType object if found. It uses the same search algorithm as above when exact_match is false. In addition to returning a pointer to the variable, it pushes onto s a BaseType pointer to each constructor type that ultimately contains name.

Parameters

  n | Find the variable whose name is name.
  s | Record the path to name.

Returns
  A pointer to the named variable.

Reimplemented from libdap::BaseType.

Definition at line 502 of file Vector.cc.

## var() [2/3]

BaseType * libdap::Vector::var | ( | const string & | n = `""`,
|  | bool | exact = `true`,
|  | btp_stack * | s = `nullptr`
| ) |  |

override virtual inherited

Returns a copy of the template array element. If the Vector contains simple data types, the template will contain the value of the last vector element accessed with the `Vector::var(int i)` function, if any. If no such access has been made, or if the Vector contains compound data types, the value held by the template instance is undefined.

Note that the parameter exact_match is not used by this mfunc.

Parameters

  n | The name of the variable to find.
  exact | Unused.
  s | Pointer to a BaseType Pointer Stack. Use this stack to record the path to the variable. By default this pointer is null, in which case it is not used.

Returns
  A pointer to the BaseType if found, otherwise null.

See also
  Vector::var

Reimplemented from libdap::BaseType.

Definition at line 469 of file Vector.cc.

## var() [3/3]

BaseType * libdap::Vector::var | ( | unsigned int | i | ) |

virtual inherited

Returns a pointer to the specified Vector element. The return pointer will reference the element itself, so multiple calls to this method should save each value before making the next call.

Parameters

  i | The index of the desired Vector element. Zero indicates the first element of the Vector.

Returns
  A pointer to a BaseType class instance containing the value of the indicated element. The BaseType pointer is locally maintained and should not be deleted or referenced. Extract the value right after the method returns.

See also
  BaseType::var

Definition at line 565 of file Vector.cc.

## var_ll()

BaseType * libdap::Vector::var_ll | ( | uint64_t | i | ) |

virtual inherited

Definition at line 567 of file Vector.cc.

## vec_resize()

void libdap::Vector::vec_resize | ( | int | l | ) |

inherited

Resizes a Vector. If the input length is greater than the current length of the Vector, new memory is allocated (the Vector moved if necessary), and the new entries are appended to the end of the array and padded with Null values. If the input length is shorter, the tail values are discarded.

Note
  This method is applicable to the compound types only.

Definition at line 613 of file Vector.cc.

## vec_resize_ll()

void libdap::Vector::vec_resize_ll | ( | int64_t | l | ) |

inherited

Definition at line 628 of file Vector.cc.

## width()

unsigned int libdap::Vector::width | ( | bool | constrained = `false` | ) | const

inline override virtual inherited

Returns the width of the data, in bytes.

Returns the number of bytes needed to hold the entire array. This is equal to `length()` (the number of elements in in the array) times the width of each element.

Deprecated:
  Use width_ll() instead

Reimplemented from libdap::BaseType.

Definition at line 191 of file Vector.h.

## width_ll()

int64_t libdap::Vector::width_ll | ( | bool | constrained = `false` | ) | const

inline override virtual inherited

Return the number of bytes needed to hold the array data.

Parameters

  constrained | If true, return the number of bytes given the current constraint

Returns
  The number of bytes needed to hold the array data, as a 64-bit integer

Reimplemented from libdap::BaseType.

Definition at line 203 of file Vector.h.

## Friends And Related Symbol Documentation

## ArrayTest

friend class ArrayTest

friend

Definition at line 209 of file Array.h.

## D4Group

friend class D4Group

friend

Definition at line 210 of file Array.h.

The documentation for this class was generated from the following files:

- Array.h
- Array.cc